<?php

namespace Drupal\mm_media\Ajax;

use Drupal\Core\Ajax\CommandInterface;

/**
 * AJAX command to refresh an MM Media Library preview.
 */
class MediaUpdatedCommand implements CommandInterface {

  /**
   * The ID for the Media entity.
   *
   * @var string
   */
  protected $mediaId;

  /**
   * Constructor.
   *
   * @param string $media_id
   *   The ID for the Media entity.
   */
  public function __construct($media_id) {
    $this->mediaId = $media_id;
  }

  /**
   * {@inheritdoc}
   */
  public function render() {
    return [
      'command' => 'media_entity_updated',
      'media_id' => $this->mediaId,
    ];
  }

}
